/******************************************************************************
**		File: Create_DataDictionary_DDL.sql
**		Name: Create_DataDictionary_DDL
**		Desc: DDL to create Data Dictionary application database.
**			  	CHECK SCRIPT AND MODIFY BEFORE YOU RUN IT!!!!!!
**              
**
**		
**		Auth: Howard Pincham
**		Date: 12/8/2005
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

IF EXISTS (
	SELECT name 
	FROM master.dbo.sysdatabases 
	WHERE name = N'DataDictionary'
	)
		DROP DATABASE [DataDictionary]
GO

CREATE DATABASE [DataDictionary]  ON (
		NAME = N'DataDictionary_Data'
	--, FILENAME = N'{your path here}\DataDictionary_Data.MDF' 
	, SIZE = 2
	, MAXSIZE = 3
	, FILEGROWTH = 10%
		) LOG ON (
			NAME = N'DataDictionary_Log'
		--, FILENAME = N'{your path here}\DataDictionary_Log.LDF' 
		, SIZE = 90
		, FILEGROWTH = 10%
			)

GO
ALTER DATABASE [DataDictionary] 
	ADD FILEGROUP [DataDictionary_Data_FG1] 
GO
ALTER DATABASE [DataDictionary] 
	ADD FILE(NAME = N'DataDictionary_Data_FG1'
		--, FILENAME = N'{your path here}\DataDictionary_Data_FG1_Data.NDF' 
		, SIZE = 100
		, MAXSIZE = 250
		, FILEGROWTH = 10%
			) TO FILEGROUP [DataDictionary_Data_FG1]
GO
ALTER DATABASE [DataDictionary] 
	ADD FILEGROUP [DataDictionary_Index_FG1] 
GO
ALTER DATABASE [DataDictionary] 
	ADD FILE(NAME = N'DataDictionary_Index_FG1'
		--, FILENAME = N'{your path here}\DataDictionary_Index_FG1_Data.NDF' 
		, SIZE = 20
		, MAXSIZE = 100
		, FILEGROWTH = 10%
			) TO FILEGROUP [DataDictionary_Index_FG1]
GO



use [DataDictionary]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APPLICATIONS_APP_DATABASES_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[APP_DATABASES] DROP CONSTRAINT APPLICATIONS_APP_DATABASES_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_TYPES_DATABASES_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[DATABASES] DROP CONSTRAINT DATABASE_TYPES_DATABASES_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS_PLATFORMS_DBMS_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[DBMS] DROP CONSTRAINT DBMS_PLATFORMS_DBMS_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[OBJTYPE_DATABASE_OBJECTS_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[DATABASE_OBJECTS] DROP CONSTRAINT OBJTYPE_DATABASE_OBJECTS_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS_DATABASES_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[DATABASES] DROP CONSTRAINT DBMS_DATABASES_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASES_DATABASE_OBJECTS_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[DATABASE_OBJECTS] DROP CONSTRAINT DATABASES_DATABASE_OBJECTS_FK1
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_OBJECTS_APP_DATABASES_FK1]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[APP_DATABASES] DROP CONSTRAINT DATABASE_OBJECTS_APP_DATABASES_FK1
GO

/****** Object:  Trigger dbo.TR_UPD_APPLICATIONS    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[TR_UPD_APPLICATIONS]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[TR_UPD_APPLICATIONS]
GO

/****** Object:  Trigger dbo.APPLICATIONSupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APPLICATIONSupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[APPLICATIONSupdate]
GO

/****** Object:  Trigger dbo.APPLICATIONSdelete    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APPLICATIONSdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[APPLICATIONSdelete]
GO

/****** Object:  Trigger dbo.DATABASE_TYPESupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_TYPESupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DATABASE_TYPESupdate]
GO

/****** Object:  Trigger dbo.DATABASE_TYPESdelete    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_TYPESdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DATABASE_TYPESdelete]
GO

/****** Object:  Trigger dbo.DBMS_PLATFORMSupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS_PLATFORMSupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DBMS_PLATFORMSupdate]
GO

/****** Object:  Trigger dbo.DBMS_PLATFORMSdelete    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS_PLATFORMSdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DBMS_PLATFORMSdelete]
GO

/****** Object:  Trigger dbo.OBJECT_TYPESupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[OBJECT_TYPESupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[OBJECT_TYPESupdate]
GO

/****** Object:  Trigger dbo.OBJECT_TYPESdelete    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[OBJECT_TYPESdelete]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[OBJECT_TYPESdelete]
GO

/****** Object:  Trigger dbo.DBMSinsert    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMSinsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DBMSinsert]
GO

/****** Object:  Trigger dbo.DBMSupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMSupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DBMSupdate]
GO

/****** Object:  Trigger dbo.TR_UPD_DATABASES    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[TR_UPD_DATABASES]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[TR_UPD_DATABASES]
GO

/****** Object:  Trigger dbo.DATABASESinsert    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASESinsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DATABASESinsert]
GO

/****** Object:  Trigger dbo.DATABASESupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASESupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DATABASESupdate]
GO

/****** Object:  Trigger dbo.TR_UPD_DATABASE_OBJECTS    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[TR_UPD_DATABASE_OBJECTS]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[TR_UPD_DATABASE_OBJECTS]
GO

/****** Object:  Trigger dbo.DATABASE_OBJECTSinsert    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_OBJECTSinsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DATABASE_OBJECTSinsert]
GO

/****** Object:  Trigger dbo.APP_DATABASESinsert    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APP_DATABASESinsert]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[APP_DATABASESinsert]
GO

/****** Object:  Trigger dbo.APP_DATABASESupdate    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APP_DATABASESupdate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[APP_DATABASESupdate]
GO

/****** Object:  Stored Procedure dbo.upLoadDBObjProperties    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upLoadDBObjProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upLoadDBObjProperties]
GO

/****** Object:  Stored Procedure dbo.upLoadRelDBObjects    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upLoadRelDBObjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upLoadRelDBObjects]
GO

/****** Object:  Stored Procedure dbo.upUpdRelDBObjects    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upUpdRelDBObjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upUpdRelDBObjects]
GO

/****** Object:  Stored Procedure dbo.upLoadRelDBNames    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upLoadRelDBNames]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upLoadRelDBNames]
GO

/****** Object:  Stored Procedure dbo.upLoadDBMSNames    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upLoadDBMSNames]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upLoadDBMSNames]
GO

/****** Object:  Stored Procedure dbo.upUpdDBObjProperties    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upUpdDBObjProperties]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upUpdDBObjProperties]
GO

/****** Object:  Stored Procedure dbo.upCheckUserid    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[upCheckUserid]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[upCheckUserid]
GO

/****** Object:  View dbo.VW_DATABASES_OBJECTS    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VW_DATABASES_OBJECTS]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[VW_DATABASES_OBJECTS]
GO

/****** Object:  View dbo.VW_TABLESPACE_COLUMNS    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VW_TABLESPACE_COLUMNS]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[VW_TABLESPACE_COLUMNS]
GO

/****** Object:  View dbo.VW_TABLESPACE_OBJECTS    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VW_TABLESPACE_OBJECTS]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[VW_TABLESPACE_OBJECTS]
GO

/****** Object:  View dbo.VW_DBMS_DATABASES    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VW_DBMS_DATABASES]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[VW_DBMS_DATABASES]
GO

/****** Object:  Table [dbo].[APP_DATABASES]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APP_DATABASES]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[APP_DATABASES]
GO

/****** Object:  Table [dbo].[DATABASE_OBJECTS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_OBJECTS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DATABASE_OBJECTS]
GO

/****** Object:  Table [dbo].[DATABASES]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASES]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DATABASES]
GO

/****** Object:  Table [dbo].[DBMS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DBMS]
GO

/****** Object:  Table [dbo].[APPLICATIONS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[APPLICATIONS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[APPLICATIONS]
GO

/****** Object:  Table [dbo].[COLUMNS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[COLUMNS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[COLUMNS]
GO

/****** Object:  Table [dbo].[DATABASE_TYPES]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DATABASE_TYPES]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DATABASE_TYPES]
GO

/****** Object:  Table [dbo].[DBMS_PLATFORMS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBMS_PLATFORMS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DBMS_PLATFORMS]
GO

/****** Object:  Table [dbo].[OBJECT_TYPES]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[OBJECT_TYPES]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[OBJECT_TYPES]
GO

/****** Object:  Table [dbo].[STG_COLUMNS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[STG_COLUMNS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[STG_COLUMNS]
GO

/****** Object:  Table [dbo].[STG_DATABASES]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[STG_DATABASES]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[STG_DATABASES]
GO

/****** Object:  Table [dbo].[STG_DATABASE_OBJECTS]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[STG_DATABASE_OBJECTS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[STG_DATABASE_OBJECTS]
GO

/****** Object:  Table [dbo].[STG_INVENTORY]    Script Date: 12/8/2005 3:06:57 PM ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[STG_INVENTORY]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[STG_INVENTORY]
GO

/****** Object:  Table [dbo].[APPLICATIONS]    Script Date: 12/8/2005 3:07:03 PM ******/
CREATE TABLE [dbo].[APPLICATIONS] (
	[APP_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[APP_ACTIVE] [char] (1) NOT NULL ,
	[APP_NAME] [varchar] (30) NOT NULL ,
	[APP_URL] [varchar] (200) NULL ,
	[APP_CONTACT] [varchar] (10) NULL ,
	[APP_DESCRIPTION] [varchar] (500) NULL ,
	[APP_SOURCEPATH] [varchar] (200) NULL ,
	[RECORD_DATE_CREATED] [smalldatetime] NULL ,
	[RECORD_DATE_MODIFIED] [smalldatetime] NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[COLUMNS]    Script Date: 12/8/2005 3:07:06 PM ******/
CREATE TABLE [dbo].[COLUMNS] (
	[COL_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[DBOBJ_ID] [int] NULL ,
	[COL_ACTIVE] [char] (1) NULL ,
	[COL_NAME] [varchar] (50) NULL ,
	[COL_TYPE] [varchar] (20) NULL ,
	[COL_SIZE] [int] NULL ,
	[COL_NULLABILITY] [varchar] (10) NULL ,
	[COL_DESCRIPTION] [varchar] (500) NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[DATABASE_TYPES]    Script Date: 12/8/2005 3:07:10 PM ******/
CREATE TABLE [dbo].[DATABASE_TYPES] (
	[DBTYPE_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[DBTYPE_NAME] [varchar] (30) NOT NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[DBMS_PLATFORMS]    Script Date: 12/8/2005 3:07:12 PM ******/
CREATE TABLE [dbo].[DBMS_PLATFORMS] (
	[PTF_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[PTF_NAME] [varchar] (30) NOT NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[OBJECT_TYPES]    Script Date: 12/8/2005 3:07:15 PM ******/
CREATE TABLE [dbo].[OBJECT_TYPES] (
	[OBJTYPE_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[OBJTYPE_NAME] [varchar] (20) NOT NULL ,
	[OBJTYPE_IS_TABLESOURCE] [char] (1) NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[STG_COLUMNS]    Script Date: 12/8/2005 3:07:18 PM ******/
CREATE TABLE [dbo].[STG_COLUMNS] (
	[DBOBJ_ID] [int] NULL ,
	[DBMS_NAME] [varchar] (50) NULL ,
	[COL_ACTIVE] [char] (1) NULL ,
	[COL_NAME] [varchar] (50) NULL ,
	[COL_TYPE] [varchar] (20) NULL ,
	[COL_SIZE] [int] NULL ,
	[COL_NULLABILITY] [varchar] (10) NULL ,
	[COL_DESCRIPTION] [varchar] (500) NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[STG_DATABASES]    Script Date: 12/8/2005 3:07:22 PM ******/
CREATE TABLE [dbo].[STG_DATABASES] (
	[dbid] [smallint] NOT NULL ,
	[DBMS_NAME] [nvarchar] (128) NULL ,
	[DB_ACTIVE] [int] NOT NULL ,
	[DB_TYPE] [int] NOT NULL ,
	[name] [nvarchar] (128) NOT NULL ,
	[totsize] [int] NULL ,
	[crdate] [datetime] NOT NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[STG_DATABASE_OBJECTS]    Script Date: 12/8/2005 3:07:25 PM ******/
CREATE TABLE [dbo].[STG_DATABASE_OBJECTS] (
	[DBOBJ_DBMS_OBJID] [sql_variant] NULL ,
	[DB_ID] [int] NOT NULL ,
	[DBMS_NAME] [varchar] (50) NULL ,
	[OBJTYPE_ID] [int] NOT NULL ,
	[DBOBJ_ACTIVE] [char] (1) NULL ,
	[DBOBJ_OWNER] [varchar] (20) NULL ,
	[DBOBJ_NAME] [varchar] (100) NULL ,
	[DBOBJ_DESCRIPTION] [varchar] (1000) NULL ,
	[DBOBJ_CREATEDATE] [smalldatetime] NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[STG_INVENTORY]    Script Date: 12/8/2005 3:07:28 PM ******/
CREATE TABLE [dbo].[STG_INVENTORY] (
	[Category] [varchar] (255) NULL ,
	[Column Name] [varchar] (255) NULL ,
	[Column Type] [varchar] (255) NULL ,
	[DB Name] [varchar] (255) NULL ,
	[Description] [varchar] (255) NULL ,
	[Developer] [varchar] (255) NULL ,
	[Object Name] [varchar] (255) NULL ,
	[Object Type] [varchar] (255) NULL ,
	[System] [varchar] (255) NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[DBMS]    Script Date: 12/8/2005 3:07:31 PM ******/
CREATE TABLE [dbo].[DBMS] (
	[DBMS_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[PTF_ID] [int] NULL ,
	[DBMS_NAME] [varchar] (20) NOT NULL ,
	[SERVER_NAME] [varchar] (20) NULL ,
	[PTF_USE] [varchar] (20) NULL ,
	[DBMS_ACTIVE] [char] (1) NOT NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[DATABASES]    Script Date: 12/8/2005 3:07:35 PM ******/
CREATE TABLE [dbo].[DATABASES] (
	[DB_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[DBMS_ID] [int] NULL ,
	[DBTYPE_ID] [int] NULL ,
	[DB_ACTIVE] [char] (1) NULL ,
	[DB_NAME] [varchar] (30) NOT NULL ,
	[DB_DBMS_DBID] [smallint] NULL ,
	[DB_SIZE] [int] NULL ,
	[RECORD_DATE_CREATED] [smalldatetime] NULL ,
	[RECORD_DATE_MODIFIED] [smalldatetime] NULL ,
	[DB_CREATEDATE] [smalldatetime] NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[DATABASE_OBJECTS]    Script Date: 12/8/2005 3:07:39 PM ******/
CREATE TABLE [dbo].[DATABASE_OBJECTS] (
	[DBOBJ_ID] [int] IDENTITY (1, 1) NOT NULL ,
	[DB_ID] [int] NOT NULL ,
	[OBJTYPE_ID] [int] NOT NULL ,
	[DBOBJ_DBMS_OBJID] [sql_variant] NULL ,
	[DBOBJ_ACTIVE] [char] (1) NULL ,
	[DBOBJ_OWNER] [varchar] (20) NOT NULL ,
	[DBOBJ_NAME] [varchar] (100) NOT NULL ,
	[DBOBJ_CONTACT] [char] (10) NULL ,
	[DBOBJ_DESCRIPTION] [varchar] (500) NULL ,
	[RECORD_DATE_CREATED] [smalldatetime] NULL ,
	[RECORD_DATE_MODIFIED] [smalldatetime] NULL ,
	[DBOBJ_CREATEDATE] [smalldatetime] NULL 
) ON [DataDictionary_Data_FG1]
GO

/****** Object:  Table [dbo].[APP_DATABASES]    Script Date: 12/8/2005 3:07:43 PM ******/
CREATE TABLE [dbo].[APP_DATABASES] (
	[DBOBJ_ID] [int] NOT NULL ,
	[APP_ID] [int] NOT NULL 
) ON [DataDictionary_Data_FG1]
GO

ALTER TABLE [dbo].[APPLICATIONS] WITH NOCHECK ADD 
	CONSTRAINT [APPLICATIONS_PK] PRIMARY KEY  CLUSTERED 
	(
		[APP_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[COLUMNS] WITH NOCHECK ADD 
	CONSTRAINT [COLUMNS_PK] PRIMARY KEY  CLUSTERED 
	(
		[COL_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[DATABASE_TYPES] WITH NOCHECK ADD 
	CONSTRAINT [DATABASE_TYPES_PK] PRIMARY KEY  CLUSTERED 
	(
		[DBTYPE_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[DBMS_PLATFORMS] WITH NOCHECK ADD 
	CONSTRAINT [DBMS_PLATFORMS_PK] PRIMARY KEY  CLUSTERED 
	(
		[PTF_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[OBJECT_TYPES] WITH NOCHECK ADD 
	CONSTRAINT [OBJECT_TYPES_PK] PRIMARY KEY  CLUSTERED 
	(
		[OBJTYPE_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[DBMS] WITH NOCHECK ADD 
	CONSTRAINT [DBMS_PK] PRIMARY KEY  CLUSTERED 
	(
		[DBMS_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[DATABASES] WITH NOCHECK ADD 
	CONSTRAINT [DATABASES_PK] PRIMARY KEY  CLUSTERED 
	(
		[DB_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[DATABASE_OBJECTS] WITH NOCHECK ADD 
	CONSTRAINT [DATABASE_OBJECTS_PK] PRIMARY KEY  CLUSTERED 
	(
		[DBOBJ_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[APP_DATABASES] WITH NOCHECK ADD 
	CONSTRAINT [APP_DATABASES_PK] PRIMARY KEY  CLUSTERED 
	(
		[APP_ID],
		[DBOBJ_ID]
	) WITH  FILLFACTOR = 90  ON [DataDictionary_Data_FG1] 
GO

ALTER TABLE [dbo].[APPLICATIONS] ADD 
	CONSTRAINT [DF_APPLICATIONS_RECORD_DATE_CREATED] DEFAULT (getdate()) FOR [RECORD_DATE_CREATED],
	CONSTRAINT [DF_APPLICATIONS_RECORD_DATE_MODIFIED] DEFAULT (getdate()) FOR [RECORD_DATE_MODIFIED]
GO

ALTER TABLE [dbo].[DBMS] ADD 
	CONSTRAINT [DF_DBMS_DBMS_ACTIVE] DEFAULT (1) FOR [DBMS_ACTIVE]
GO

ALTER TABLE [dbo].[DATABASES] ADD 
	CONSTRAINT [DF_DATABASES_RECORD_DATE_CREATED] DEFAULT (getdate()) FOR [RECORD_DATE_CREATED],
	CONSTRAINT [DF_DATABASES_RECORD_DATE_MODIFIED] DEFAULT (getdate()) FOR [RECORD_DATE_MODIFIED]
GO

ALTER TABLE [dbo].[DATABASE_OBJECTS] ADD 
	CONSTRAINT [DF__DATABASE___RECOR__49C3F6B7] DEFAULT (getdate()) FOR [RECORD_DATE_CREATED],
	CONSTRAINT [DF__DATABASE___RECOR__4AB81AF0] DEFAULT (getdate()) FOR [RECORD_DATE_MODIFIED]
GO

ALTER TABLE [dbo].[DBMS] ADD 
	CONSTRAINT [DBMS_PLATFORMS_DBMS_FK1] FOREIGN KEY 
	(
		[PTF_ID]
	) REFERENCES [dbo].[DBMS_PLATFORMS] (
		[PTF_ID]
	) ON UPDATE CASCADE 
GO

alter table [dbo].[DBMS] nocheck constraint [DBMS_PLATFORMS_DBMS_FK1]
GO

ALTER TABLE [dbo].[DATABASES] ADD 
	CONSTRAINT [DATABASE_TYPES_DATABASES_FK1] FOREIGN KEY 
	(
		[DBTYPE_ID]
	) REFERENCES [dbo].[DATABASE_TYPES] (
		[DBTYPE_ID]
	) ON UPDATE CASCADE ,
	CONSTRAINT [DBMS_DATABASES_FK1] FOREIGN KEY 
	(
		[DBMS_ID]
	) REFERENCES [dbo].[DBMS] (
		[DBMS_ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

alter table [dbo].[DATABASES] nocheck constraint [DATABASE_TYPES_DATABASES_FK1]
GO

ALTER TABLE [dbo].[DATABASE_OBJECTS] ADD 
	CONSTRAINT [DATABASES_DATABASE_OBJECTS_FK1] FOREIGN KEY 
	(
		[DB_ID]
	) REFERENCES [dbo].[DATABASES] (
		[DB_ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE ,
	CONSTRAINT [OBJTYPE_DATABASE_OBJECTS_FK1] FOREIGN KEY 
	(
		[OBJTYPE_ID]
	) REFERENCES [dbo].[OBJECT_TYPES] (
		[OBJTYPE_ID]
	) ON UPDATE CASCADE 
GO

alter table [dbo].[DATABASE_OBJECTS] nocheck constraint [OBJTYPE_DATABASE_OBJECTS_FK1]
GO

ALTER TABLE [dbo].[APP_DATABASES] ADD 
	CONSTRAINT [APPLICATIONS_APP_DATABASES_FK1] FOREIGN KEY 
	(
		[APP_ID]
	) REFERENCES [dbo].[APPLICATIONS] (
		[APP_ID]
	) ON UPDATE CASCADE ,
	CONSTRAINT [DATABASE_OBJECTS_APP_DATABASES_FK1] FOREIGN KEY 
	(
		[DBOBJ_ID]
	) REFERENCES [dbo].[DATABASE_OBJECTS] (
		[DBOBJ_ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

alter table [dbo].[APP_DATABASES] nocheck constraint [APPLICATIONS_APP_DATABASES_FK1]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  View dbo.VW_DBMS_DATABASES    Script Date: 12/8/2005 3:07:46 PM ******/

/****** Object:  View dbo.VW_DBMS_DATABASES    Script Date: 10/22/2004 8:32:27 AM ******/
CREATE VIEW dbo.VW_DBMS_DATABASES
AS
SELECT     dbo.DBMS.DBMS_NAME, dbo.DATABASE_TYPES.DBTYPE_NAME, dbo.DATABASES.DB_NAME, dbo.DBMS_PLATFORMS.PTF_NAME, 
                      dbo.DBMS.PTF_USE, dbo.DATABASES.DB_SIZE, dbo.DATABASES.DB_CREATEDATE
FROM         dbo.DATABASES INNER JOIN
                      dbo.DBMS ON dbo.DATABASES.DBMS_ID = dbo.DBMS.DBMS_ID INNER JOIN
                      dbo.DATABASE_TYPES ON dbo.DATABASES.DBTYPE_ID = dbo.DATABASE_TYPES.DBTYPE_ID INNER JOIN
                      dbo.DBMS_PLATFORMS ON dbo.DBMS.PTF_ID = dbo.DBMS_PLATFORMS.PTF_ID


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  View dbo.VW_DATABASES_OBJECTS    Script Date: 12/8/2005 3:07:47 PM ******/

/****** Object:  View dbo.VW_DATABASES_OBJECTS    Script Date: 10/22/2004 8:32:26 AM ******/
/*Describes databases and their associated objects*/
CREATE VIEW dbo.VW_DATABASES_OBJECTS
AS
SELECT     dbo.DBMS.DBMS_NAME, dbo.DATABASE_TYPES.DBTYPE_NAME, dbo.DATABASES.DB_NAME, dbo.DATABASE_OBJECTS.DBOBJ_NAME, 
                      dbo.DATABASE_OBJECTS.DBOBJ_DESCRIPTION, dbo.OBJECT_TYPES.OBJTYPE_NAME, dbo.DATABASE_OBJECTS.DBOBJ_CREATEDATE, 
                      dbo.DATABASE_OBJECTS.DBOBJ_CONTACT, dbo.DATABASE_OBJECTS.DBOBJ_OWNER
FROM         dbo.DATABASES INNER JOIN
                      dbo.DBMS ON dbo.DATABASES.DBMS_ID = dbo.DBMS.DBMS_ID INNER JOIN
                      dbo.DATABASE_TYPES ON dbo.DATABASES.DBTYPE_ID = dbo.DATABASE_TYPES.DBTYPE_ID INNER JOIN
                      dbo.DATABASE_OBJECTS ON dbo.DATABASES.DB_ID = dbo.DATABASE_OBJECTS.DB_ID INNER JOIN
                      dbo.OBJECT_TYPES ON dbo.DATABASE_OBJECTS.OBJTYPE_ID = dbo.OBJECT_TYPES.OBJTYPE_ID


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  View dbo.VW_TABLESPACE_COLUMNS    Script Date: 12/8/2005 3:07:48 PM ******/

/****** Object:  View dbo.VW_TABLESPACE_COLUMNS    Script Date: 10/22/2004 8:32:27 AM ******/
/*Describes databases and their associated objects



*/
CREATE VIEW dbo.VW_TABLESPACE_COLUMNS
AS
SELECT     dbo.DBMS.DBMS_NAME, dbo.DATABASES.DB_NAME, dbo.DATABASE_OBJECTS.DBOBJ_NAME, dbo.DATABASE_OBJECTS.DBOBJ_CONTACT, 
                      dbo.COLUMNS.COL_NAME, dbo.COLUMNS.COL_TYPE, dbo.COLUMNS.COL_SIZE, dbo.COLUMNS.COL_NULLABILITY, 
                      dbo.COLUMNS.COL_DESCRIPTION
FROM         dbo.DATABASES INNER JOIN
                      dbo.DBMS ON dbo.DATABASES.DBMS_ID = dbo.DBMS.DBMS_ID INNER JOIN
                      dbo.DATABASE_TYPES ON dbo.DATABASES.DBTYPE_ID = dbo.DATABASE_TYPES.DBTYPE_ID INNER JOIN
                      dbo.DATABASE_OBJECTS ON dbo.DATABASES.DB_ID = dbo.DATABASE_OBJECTS.DB_ID INNER JOIN
                      dbo.OBJECT_TYPES ON dbo.DATABASE_OBJECTS.OBJTYPE_ID = dbo.OBJECT_TYPES.OBJTYPE_ID INNER JOIN
                      dbo.COLUMNS ON dbo.DATABASE_OBJECTS.DBOBJ_ID = dbo.COLUMNS.DBOBJ_ID
WHERE     (dbo.OBJECT_TYPES.OBJTYPE_IS_TABLESOURCE = '1')


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  View dbo.VW_TABLESPACE_OBJECTS    Script Date: 12/8/2005 3:07:48 PM ******/

/****** Object:  View dbo.VW_TABLESPACE_OBJECTS    Script Date: 10/22/2004 8:32:28 AM ******/
/*Describes databases and their associated objects*/
CREATE VIEW dbo.VW_TABLESPACE_OBJECTS
AS
SELECT     dbo.DBMS.DBMS_NAME, dbo.DATABASE_TYPES.DBTYPE_NAME, dbo.DATABASES.DB_NAME, dbo.DATABASE_OBJECTS.DBOBJ_NAME, 
                      dbo.DATABASE_OBJECTS.DBOBJ_DESCRIPTION, dbo.OBJECT_TYPES.OBJTYPE_NAME, dbo.DATABASE_OBJECTS.DBOBJ_CREATEDATE, 
                      dbo.DATABASE_OBJECTS.DBOBJ_CONTACT, dbo.DATABASE_OBJECTS.DBOBJ_OWNER
FROM         dbo.DATABASES INNER JOIN
                      dbo.DBMS ON dbo.DATABASES.DBMS_ID = dbo.DBMS.DBMS_ID INNER JOIN
                      dbo.DATABASE_TYPES ON dbo.DATABASES.DBTYPE_ID = dbo.DATABASE_TYPES.DBTYPE_ID INNER JOIN
                      dbo.DATABASE_OBJECTS ON dbo.DATABASES.DB_ID = dbo.DATABASE_OBJECTS.DB_ID INNER JOIN
                      dbo.OBJECT_TYPES ON dbo.DATABASE_OBJECTS.OBJTYPE_ID = dbo.OBJECT_TYPES.OBJTYPE_ID
WHERE     (dbo.OBJECT_TYPES.OBJTYPE_IS_TABLESOURCE = '1')


GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  Trigger dbo.TR_UPD_APPLICATIONS    Script Date: 12/8/2005 3:07:54 PM ******/

/****** Object:  Trigger dbo.TR_UPD_APPLICATIONS    Script Date: 10/22/2004 8:32:33 AM ******/

/****** Object:  Trigger dbo.TR_UPD_APPLICATIONS    Script Date: 8/6/2004 2:48:17 PM ******/
CREATE  TRIGGER TR_UPD_APPLICATIONS
	ON APPLICATIONS
	FOR UPDATE 
	NOT FOR REPLICATION
	AS 
		--No rows affected, exit immediately
		IF @@ROWCOUNT = 0 RETURN
		--Update the Modified Date for all the records that have been modified
		UPDATE APPLICATIONS
			SET RECORD_DATE_MODIFIED = GETDATE()
			FROM APPLICATIONS ORG 
				INNER JOIN INSERTED UPD 
				ON ORG.APP_ID = UPD.APP_ID



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  Trigger dbo.TR_UPD_DATABASES    Script Date: 12/8/2005 3:08:02 PM ******/

/****** Object:  Trigger dbo.TR_UPD_DATABASES    Script Date: 10/22/2004 8:32:40 AM ******/

/****** Object:  Trigger dbo.TR_UPD_DATABASES    Script Date: 4/5/2004 10:38:30 AM ******/
CREATE  TRIGGER TR_UPD_DATABASES
	ON DATABASES
	FOR UPDATE 
	NOT FOR REPLICATION
	AS 
		--No rows affected, exit immediately
		IF @@ROWCOUNT = 0 RETURN
		--Update the Modified Date for all the records that have been modified
		UPDATE DATABASES
			SET RECORD_DATE_MODIFIED = GETDATE()
			FROM DATABASES ORG 
				INNER JOIN INSERTED UPD 
				ON ORG.DB_ID = UPD.DB_ID



GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  Trigger dbo.TR_UPD_DATABASE_OBJECTS    Script Date: 12/8/2005 3:08:05 PM ******/

/****** Object:  Trigger dbo.TR_UPD_DATABASE_OBJECTS    Script Date: 10/22/2004 8:32:41 AM ******/

/****** Object:  Trigger dbo.TR_UPD_DATABASE_OBJECTS    Script Date: 8/6/2004 2:40:51 PM ******/
CREATE  TRIGGER TR_UPD_DATABASE_OBJECTS

	ON dbo.DATABASE_OBJECTS

	FOR UPDATE 

	NOT FOR REPLICATION

	AS 

		--No rows affected, exit immediately

		IF @@ROWCOUNT = 0 RETURN

		--Update the Modified Date for all the records that have been modified

		UPDATE DATABASE_OBJECTS

			SET RECORD_DATE_MODIFIED = GETDATE()

			FROM DATABASE_OBJECTS ORG 

				INNER JOIN INSERTED UPD 

				ON ORG.DBOBJ_ID = UPD.DBOBJ_ID





GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
